#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "LidarPerception_PubDataWrapper.h"
#include "LidarPerception_SubDataWrapper.h"
#include "lidar_perception/executable.h"

#include "LidarPerception_GeneralWrapper.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) :
_LiDARPerception2Fusion_Provide("lidar_perception/lidar_perception/LiDARPerception2FusionPPort" ,mainLog),
_LiDAR2LiDARPerception_Required("lidar_perception/lidar_perception/LiDARInno2LiDARPerceptionRPort", mainLog),
_HesaiRight_Required("lidar_perception/lidar_perception/LiDARHesaiRight2LiDARPerceptionRPort", mainLog),
_HesaiLeft_Required("lidar_perception/lidar_perception/LiDARHesaiLeft2LiDARPerceptionRPort", mainLog),
_SLAMLocalEgoOdom2SWC_Required("lidar_perception/lidar_perception/SLAMLocalEgoOdom2SWCRPort", mainLog),
_VED2LiDARPerception_Required("lidar_perception/lidar_perception/VED2LiDARPerceptionRPort", mainLog),
_INS_CAN2SWC_100HZ_2SWC_Required("lidar_perception/lidar_perception/INS_CAN2SWC_100HZ_2LiDARPerRPort", mainLog),
_IMU_CAN2SWC_100HZ_2SWC_Required("lidar_perception/lidar_perception/IMU_CAN2SWC_100HZ_2LiDARPerRPort", mainLog)
{
	//Provides
	_LiDARPerception2Fusion_Provide.Init();

	//Requireds
	_LiDAR2LiDARPerception_Required.Init();
	_SLAMLocalEgoOdom2SWC_Required.Init();
	_VED2LiDARPerception_Required.Init();
	_INS_CAN2SWC_100HZ_2SWC_Required.Init();
	_IMU_CAN2SWC_100HZ_2SWC_Required.Init();

}

GeneralWrapper::~GeneralWrapper() {
	_LiDAR2LiDARPerception_Required.Destroy();
	_SLAMLocalEgoOdom2SWC_Required.Destroy();
	_VED2LiDARPerception_Required.Destroy();
	_INS_CAN2SWC_100HZ_2SWC_Required.Destroy();
	_IMU_CAN2SWC_100HZ_2SWC_Required.Destroy();
}
